// ============================================================================
//
// Copyright (c) 2010-2016, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ============================================================================


#include "Column.h"
#include "Cell.h"
#include "Common.h"
#include "Grid.h"



Column::Column(int size, int number)
       :Element (size)
{
    this->number = number;
}

void Column::init (Grid* grid) 
{
    cells = new Cell*[size];
    for (int rowCounter = 0; rowCounter < this->size; rowCounter++) 
    {
        Cell* cell = grid->getCell(rowCounter, number);
        cells[rowCounter] = cell;
        cell->setColumn (this);
    }
}

const char* Column::getName()
{
    std::string nameStr;
    std::ostringstream oss;
    oss << "Column (" << (number + 1) << ")";
    nameStr = oss.str();
    
    return nameStr.c_str();
}

int Column::getNumber() 
{
   return this->number; 
}

Column::~Column()
{
}
