// ============================================================================
//
// Copyright (c) 2010-2016, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ============================================================================



#include "Common.h"
#include "Cell.h"

int random (int minValue, int maxValue)
{
    double randDouble = (double)rand() / (double)RAND_MAX;

    int retRand = minValue + (int) (randDouble * (double) ((maxValue - minValue) + 1));

    //wxLogMessage("int retRand = %d + (int) (%f * (double) ((%d - %d) + 1)) = %d", minValue, randDouble, maxValue, minValue, retRand);

    // safety net : the +1 above is a risky hack
    if (retRand > maxValue)
    {
        retRand = maxValue;
    }
    return retRand;
}

char* convertInt(int number)
{
    std::string nameStr;
    std::ostringstream oss;
    oss << number;
    nameStr = oss.str();

    return (char*) nameStr.c_str();
}

wxString std2wx(std::string input)
{
#if (wxUSE_UNICODE)
	int size = input.size() + 1;
	wchar_t *buffer = new wchar_t[size*4];	// 32bit chars?
	wxEncodingConverter wxec;
	wxec.Init(wxFONTENCODING_ISO8859_1, wxFONTENCODING_UNICODE);
	wxec.Convert(input.c_str(), buffer);
	wxString temp(buffer);
	delete buffer;
	return temp;
#else
	return wxString(input.c_str());
#endif
}

// allocation and deletion functions
char * StrAllocThrowA(size_t cchSize)
{
	return new char[cchSize];
}
wchar_t * StrAllocThrowW(size_t cchSize)
{
	return new wchar_t[cchSize];
}
void StrFreeA(char * s)
{
	delete[] s;
}
void StrFreeW(wchar_t * s)
{
	delete[] s;
}

//C++ overloading, simplier
inline void StrFree( char   * s) { return StrFreeA(s); }
inline void StrFree(wchar_t * s) { return StrFreeW(s); }

// Ann now the conversion function
wchar_t * ambstowcs(char const *sczA)
{
	size_t const cchLenA = strlen(sczA);
	size_t const cchLenW = mbstowcs(NULL, sczA, cchLenA+1);
	wchar_t * szW = StrAllocThrowW(cchLenW+1);
	mbstowcs(szW, sczA, cchLenA+1);
	return szW;
}
