// ============================================================================
//
// Copyright (c) 2010-2016, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ============================================================================


#ifndef COMMON_H_
#define COMMON_H_


#include <stdlib.h>

#include <wx/wx.h>
#include <wx/encconv.h>

#include <stdio.h>
#include <stdlib.h>
#include <sstream>

#include <iostream>
#include <exception>

#include <list>


#ifndef CELL_TYPE_ENUM_
#define CELL_TYPE_ENUM_
enum CellType
{
    sdST_INPUT,
    sdST_COMPUTED,
    sdST_GUESS,
    sdST_POSS,
    sdST_FIXED
};
#endif



int random (int minValue, int maxValue);

char* convertInt(int number);

wxString std2wx(std::string input);

wchar_t * ambstowcs(char const *sczA);


class SoldokuException : public std::exception
{
private:
    char* message;
public:
    SoldokuException (char* message)
    {
        this->message = message;
    }
    virtual const char* what() const throw()
    {
        return message;
    }
};

#endif /*COMMON_H_*/
