// ============================================================================
//
// Copyright (c) 2010-2016, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ============================================================================



#include "DifficultyChooser.h"


#include "MainFrame.h"


BEGIN_EVENT_TABLE(DifficultyChooser, wxDialog)
    EVT_BUTTON(wxID_YES,      DifficultyChooser::OnEasy)
    EVT_BUTTON(wxID_YESTOALL, DifficultyChooser::OnDifficult)
END_EVENT_TABLE();


DifficultyChooser::DifficultyChooser(MainFrame* mainFrame)
                  :wxDialog(mainFrame, wxID_ANY, wxT("Diff."), wxDefaultPosition, wxDefaultSize, wxDEFAULT_DIALOG_STYLE)
{
    this->mainFrame = mainFrame;

    vbox = new wxBoxSizer(wxVERTICAL);

    vbox->Add(new wxButton(this, wxID_YES, wxT("Easy")));
    vbox->Add(new wxButton(this, wxID_YESTOALL, wxT("Difficult")));

    vbox->SetSizeHints(this);

    this->SetSizer(vbox);
}


void DifficultyChooser::OnEasy(wxCommandEvent& event)
{
    this->mainFrame->generateGrid(0);
    this->Close();
}

void DifficultyChooser::OnDifficult(wxCommandEvent& event)
{
    this->mainFrame->generateGrid(1);
    this->Close();
}


DifficultyChooser::~DifficultyChooser()
{
}
