// ============================================================================
//
// Copyright (c) 2010-2016, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ============================================================================


#ifndef GENERATOR_H_
#define GENERATOR_H_


#include <wx/wx.h>
#include <wx/wxprec.h>
#include <wx/dcbuffer.h>
#include <wx/progdlg.h>

#ifndef GRID_CLASS_
class Grid;
#endif

#ifndef SOLVER_CLASS_
class Solver;
#endif

#ifndef CELL_CLASS_
class Cell;
#endif

#ifndef BOARD_CLASS_
class Board;
#endif


#ifndef GENERATOR_CLASS_
#define GENERATOR_CLASS_

class Generator
{
public:
    Grid* generateGrid (int difficulty);
    Generator(Board* board, int size);
    
private:
    Board* board;
    int size;
    Grid* DEFAULT_GRID;

    void addOneCellForEachValue(Grid *& originalGrid, Grid *& retGrid);
    void swapCells(Cell *sourceCell, Cell *destCell);
    Grid *removeValues(Grid *grid);
    Grid *removeValuesOld(Grid *grid);
    Grid *newRandomGrid();
    void addBestValuesUntilSolvable(Grid *retGrid, Grid *originalGrid);
    void addValuesRandomly(Grid *retGrid, Grid *originalGrid);
    void removeGuessableValues(Grid *retGrid, Grid *originalGrid);
    void tryReaddingValues(Grid *retGrid, Grid *originalGrid);
    int performPossibleRemoves(Grid *grid, Cell *exception = NULL);
};

#endif


#endif /*GENERATOR_H_*/
