// ============================================================================
//
// Copyright (c) 2010-2016, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ============================================================================


#include "Group.h"

void Group::addCell (Cell* cell, int number)
{
    cellsWithSamePoss.push_back(cell);
    cellsNbrWithSamePoss.push_back(number);
}

int Group::size() 
{
    return cellsWithSamePoss.size();
}

std::vector<int>* Group::listCellsWithPossibility (int possibility)
{
    std::vector<int>* retList = new std::vector<int>();  
   
    int cellsWithSamePossSize = cellsWithSamePoss.size(); 
    for (int counter = 0; counter < cellsWithSamePossSize; counter++)
    {
        if (cellsWithSamePoss[counter]->hasPossibility(possibility))
        {   
            retList->push_back(cellsNbrWithSamePoss[counter]);
        }
    }
    
    return retList;
}

void Group::highlight (Solver* solver)
{
    int cellsWithSamePossSize = cellsWithSamePoss.size(); 
    for (int counter = 0; counter < cellsWithSamePossSize; counter++)
    {
        cellsWithSamePoss[counter]->setHighlight (true);
    }
    solver->doRefresh();    
    solver->sleep();    
    
    for (int counter = 0; counter < cellsWithSamePossSize; counter++)
    {
        cellsWithSamePoss[counter]->setHighlight (false);
    }
}

bool Group::contains  (int value)
{
    int groupSize = cellsNbrWithSamePoss.size();
    for (int i = 0; i < groupSize; i++)
    {
        if (cellsNbrWithSamePoss[i] == value)
        {
            return true;
        }
    }
    
    return false;
}
