// ============================================================================
//
// Copyright (c) 2010-2016, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ============================================================================


#ifndef GROUP_H_
#define GROUP_H_


#include "Common.h"

#include "Cell.h"
#include "Solver.h"


#ifndef CELL_CLASS
class Cell;
#endif

#ifndef SOLVER_CLASS
class Solver;
#endif


#ifndef GROUP_CLASS_
#define GROUP_CLASS_

class Group
{
    
private:
    std::vector<Cell*> cellsWithSamePoss;
    std::vector<int> cellsNbrWithSamePoss;
    
public:
   void addCell (Cell* cell, int number);
   int size();
   bool contains  (int value);
   std::vector<int>* listCellsWithPossibility (int possibility);
   
   void highlight (Solver* solver);
};

#endif


#endif
