// ============================================================================
//
// Copyright (c) 2010-2016, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ============================================================================


#ifndef INITVALUESHOLDER_H_
#define INITVALUESHOLDER_H_


#include <wx/wx.h>

#include <vector>


#include "Common.h"


#ifndef INITVALUESHOLDER_CLASS_
#define INITVALUESHOLDER_CLASS_

class InitValuesHolder
{
    
public:
	InitValuesHolder(int size);
	virtual ~InitValuesHolder();
	
	void setCellValue (int row, int column, int value);
	int getCellValue (int row, int column);

	void setCellType (int row, int column, CellType cellType);
	CellType getCellType (int row, int column);

	void setCellPossibilities (int row, int column, std::vector<int>* possibilities);
	std::vector<int>* getCellPossibilities (int row, int column);
	
	int getSize();
	
private:
    int size;
    int** cellValues;
    CellType** cellTypes;
    std::vector<int>*** cellPossibilities;
};

#endif


#endif /*INITVALUESHOLDER_H_*/
