// ============================================================================
//
// Copyright (c) 2010-2016, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ============================================================================


#include "Row.h"

#include "Common.h"
#include "Cell.h"
#include "Grid.h"


Row::Row(int size, int number)
    :Element (size)
{
    this->size = size;
    this->number = number;
}

void Row::init (Grid* grid) 
{    
    cells = new Cell*[size];
    for (int colCounter = 0; colCounter < size; colCounter++) 
    {
        Cell* cell = grid->getCell(number, colCounter);
        cells[colCounter] = cell;
        cell->setRow (this);
    }
}

const char* Row::getName()
{
    std::string nameStr;
    std::ostringstream oss;
    oss << "Row (" << (number + 1) << ")";
    nameStr = oss.str();
    
    return nameStr.c_str();
}

int Row::getNumber() 
{
   return this->number; 
}

int Row::getSize()
{
   return this->size;
}

Row::~Row()
{
}
