// ============================================================================
//
// Copyright (c) 2010-2016, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ============================================================================


#include "SolverThread.h"

#include "Common.h"


SolverThread::SolverThread(Grid* grid, Board* board)
             :wxThread (wxTHREAD_JOINABLE), Solver(false, board)
{
    this->grid = grid;

    cont = false;
}

void* SolverThread::Entry()
{
#ifdef __WXDEBUG__
    wxLogMessage (std2wx("SolverThread::Entry - Thread running"));
#endif
    grid->start(this);

    //stopResolving ();
    board->resolvingFinished();

    grid->stop();

    return 0;
}

void SolverThread::OnExit()
{
    grid->stop();
}

bool SolverThread::shouldCont (void)
{
    return cont;
}

void SolverThread::startResolving()
{
#ifdef __WXDEBUG__
    wxLogMessage (std2wx("SolverThread::startResolving - Creating thread"));
#endif
    cont = true;
    Create();
    Run();
}

void SolverThread::stopResolving ()
{
    cont = false;
#ifndef __WXMSW__
    wait();
#endif	
#ifdef __WXDEBUG__
    wxLogMessage (std2wx("SolverThread::stopResolving - Thread terminating"));
#endif
}


SolverThread::~SolverThread()
{
    Delete();
#ifdef __WXDEBUG__
    wxLogMessage (std2wx("SolverThread::~SolverThread - Thread deleted"));
#endif
}
