// ============================================================================
//
// Copyright (c) 2010-2016, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ============================================================================


#ifndef SOLVERTHREAD_H_
#define SOLVERTHREAD_H_


#define Uses_wxThread

#include <wx/wx.h>
#include <wx/wxprec.h>
#include <wx/dcbuffer.h>

#include "Board.h"
#include "Solver.h"
#include "Grid.h"


#ifndef GRID_CLASS_
class Grid;
#endif

#ifndef BOARD_CLASS_
class Board;
#endif

#ifndef SOLVER_CLASS_
class Solver;
#endif



#ifndef SOLVERTHREAD_CLASS_
#define SOLVERTHREAD_CLASS_


class SolverThread : public wxThread, public Solver
{
public:
	SolverThread(Grid* grid, Board* board);
	virtual ~SolverThread();	
	
	virtual bool shouldCont (void); 
	void startResolving();
	void stopResolving ();
    
protected:	
    virtual void* Entry(); 
    virtual void OnExit();
    
private:
    bool cont;
    Grid* grid;
   
};


#endif

#endif /*SOLVERTHREAD_H_*/
