// ============================================================================
//
// Copyright (c) 2010-2016, niceideas.ch - Jerome Kehrli
//
// You may distribute this code under the terms of the GNU LGPL license
// (http://www.gnu.org/licenses/lgpl.html). [^]
//
// ============================================================================


#ifndef SQUARE_H_
#define SQUARE_H_

#include <wx/wx.h>
#include <wx/encconv.h>


#include "Element.h"

#ifndef GRID_CLASS_
class Grid;
#endif

#ifndef ELEMENT_CLASS_
class Element;
#endif



#ifndef SQUARE_CLASS_
#define SQUARE_CLASS_

class Square : public Element
{
    
private:
    int rowPosition;
    int colPosition;
    int size;
    
    wxCoord posX;
    wxCoord posY;
    wxCoord sizeX;
    wxCoord sizeY;    
    
public:
    Square(int size, int rowPosition, int colPosition);
    void init (Grid* Grid);
    virtual ~Square();
    void initPosition (wxCoord posX, wxCoord posY, wxCoord sizeX, wxCoord sizeY);
    void draw (wxDC* dc);

    virtual const char* getName();
    
    bool discardPossibilityFromOther (int possibility, Element* element);
};

#endif


#endif
